;XtraKeys v.2.31
;Copyright (C) Kevin Kofler, 2000-2002
;please read the readme file before using this file
;Please DO NOT distribute modified versions without my
;permission!

 include "OS.h" ;You need the version included with TeOS
                ;or the one given with TIGCC 0.91 or
                ;higher (because of the ROM_CALL2 macro).
 xdef _nostub ;no kernel required
 xdef _ti89 ;This is for the TI-89.
 xdef _ti92plus ;This is also for the TI-92+.
 xdef _main ;This is a program, not a library.

_main:
 include "h220xtsr.h"
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
;Detect the address of the home screen entry line parameters (needed for the
;automatic adding of ans(1) before ^2, ^3 and ^-1).
;Thanks to Samuel Stearley for this one!
 move.l $c8,a0
 move.l TE_select*4(a0),d0 ;get the address of TE_select
 move.l HomeExecute*4(a0),a0 ;get the address of HomeExecute
;The code for HomeExecute contains a jsr to TE_select preceded by a pea of the
;required address.
search_loop:
 addq.l	#2,a0 ;code is word-aligned, so no need to check every byte
 cmp.l (a0),d0 ;compare with the address of TE_select
 bne search_loop
 clr.l d0
 move.w -4(a0),d0 ;get address of the home screen entry line
 add.l #16,d0 ;add 16 to the address to point it to the length of the text
;End of the home screen entry line parameters detection
 pea.l event(PC) ;prepare EV_sendEvent call
 move.w #-2,-(a7)
 move.l $c8,a0
 move.l ScrRect*4(a0),a0
 cmp.b #200,2(a0) ;check if TI-92+/V200
 bcc ti92plus ;routine for TI-89
 move.l d0,params89
 move.l #$116,event_key ;change the keycode to CATALOG
 ROM_CALL EV_sendEvent ;send the CATALOG keypress
 ROM_CALL2 FirstWindow
 move.l (a4),catalog89 ;get the address of the catalog window
 move.l #$10001108,event_key ;change the keycode to Quit
 ROM_CALL EV_sendEvent ;send the Quit keypress
 addq.l #6,a7
 ROM_CALL cmd_disphome ;switch to the HOME screen
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 addq.l #1,a4
 move.l a4,window89 ;get the address of the home screen window
 ROM_CALL2 EV_hook ;get the location of the event hook
 move.l (a4),oldevent89 ;save the old event hook and call
                        ;it from the event routine
 move.l #(endevent89-newevent89),-(a7)
 ROM_CALL HeapAllocHigh ;allocate a handle for the new
                        ;event routine
 addq.l #2,a7
 tst.w d0 ;check if NULL handle
 beq nomem ;if yes, display "no mem" error message
 move.w d0,(a7)
 ROM_CALL HeapDeref ;get ("dereference") the address
 move.l a0,a3 ;save the address to a3 for further use
 subq.l #2,a7
 move.l #(endevent89-newevent89),(a7)
 pea.l newevent89(PC)
 move.l a0,-(a7)
 ROM_CALL memcpy ;copy the event routine to the handle
 bra install_EV_hook ;jump to common routine for TI-89 and TI-92+
ti92plus: ;routine for TI-92+
 move.l d0,params92p
 move.l #$10001108,event_key ;change the keycode to Quit
 ROM_CALL EV_sendEvent ;send the Quit keypress
 addq.l #6,a7
 move.l $c8,a0
 cmp.l #cmd_disphome,-4(a0) ;check if cmd_disphome is available
 bls nodisphome ;If it isn't, we are on a TI-92+ AMS 1.00. That means that there
                ;is no icon desktop anyway, so we already are on the home screen.
 move.l cmd_disphome*4(a0),a0
 jsr (a0) ;switch to the HOME screen
nodisphome:
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 addq.l #1,a4
 move.l a4,window92p ;get the address of the home screen window
 ROM_CALL2 EV_hook ;get the location of the event hook
 move.l (a4),oldevent92p ;save the old event hook and call
                         ;it from the event routine
 move.l #(endevent92p-newevent92p),-(a7)
 ROM_CALL HeapAllocHigh ;allocate a handle for the new
                        ;event routine
 addq.l #2,a7
 tst.w d0
 beq nomem
 move.w d0,(a7)
 ROM_CALL HeapDeref ;get ("dereference") the address
 move.l a0,a3 ;save the address to a3 for further use
 subq.l #2,a7
 move.l #(endevent92p-newevent92p),(a7)
 pea.l newevent92p(PC)
 move.l a0,-(a7)
 ROM_CALL memcpy ;copy the event routine to the handle
install_EV_hook: ;common routine for TI-89 and TI-92+
 lea.l 12(a7),a7 ;shorter as add(a).l #12,a7
 ROM_CALL2 EV_hook ;get the location of the event hook
 add.l #$40010,a3 ;add: - $40000 for HW2 AMS 2.0x without
                  ;       HW2Patch
                  ;     - $10 to skip the uninstall
                  ;       information (need the start of
                  ;       the executable code here)
 move.l a3,(a4) ;install the event hook
 pea.l foldersym(PC)
 ROM_CALL FolderFind ;check if the "x" folder exists
 cmp.b #3,d0
 beq skipfolder ;if yes, don't try to create it
 cmp.b #4,d0
 bne skipall ;if error, skip all the rest
 ROM_CALL FolderAdd ;create the "x" folder
 tst.w d0
 beq skipall ;if error, skip all the rest
skipfolder:
 addq.l #4,a7
 pea.l rootsym(PC)
 ROM_CALL SymFind ;check if "x\root" exists
 tst.w d0
 bne skiproot ;if yes, skip
 move.l #19,(a7)
 ROM_CALL HeapAlloc
 tst.w d0
 beq skiproot ;if there is an error, skip
 move.w d0,d3
 move.w d0,(a7)
 ROM_CALL HeapDeref
 clr.w (a7)
 pea.l rootdata(PC)
 pea.l (a0)
 ROM_CALL memcpy
 addq.l #8,a7
 pea.l rootsym(PC)
 ROM_CALL SymAdd ;create the "x\root" function
 tst.w d0
 beq skiproot2 ;if there is an error, skip
 move.l d0,(a7)
 ROM_CALL DerefSym
 move.w d3,12(a0) ;set handle
 clr.l -(a7)
 ROM_CALL EM_moveSymToExtMem ;archive "x\root"
 addq.l #8,a7
skiproot:
 addq.l #4,a7
 pea.l logysym(PC)
 ROM_CALL SymFind ;check if "x\logy" exists
 tst.w d0
 bne skiplogy ;if yes, skip
 move.l #17,(a7)
 ROM_CALL HeapAlloc
 tst.w d0
 beq skiplogy ;if there is an error, skip
 move.w d0,d3
 move.w d0,(a7)
 ROM_CALL HeapDeref
 clr.w (a7)
 pea.l logydata(PC)
 pea.l (a0)
 ROM_CALL memcpy
 addq.l #8,a7
 pea.l logysym(PC)
 ROM_CALL SymAdd ;create the "x\logy" function
 tst.w d0
 beq skiplogy2 ;if there is an error, skip
 move.l d0,(a7)
 ROM_CALL DerefSym
 move.w d3,12(a0) ;set handle
 clr.l -(a7)
 ROM_CALL EM_moveSymToExtMem ;archive "x\logy"
 addq.l #8,a7
skiplogy:
skipall:
 addq.l #4,a7
 pea.l installedST(PC) ;show "installed" message
showmsg:
 ROM_CALL ST_helpMsg
 addq.l #4,a7
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
skiproot2:
 move.w d3,(a7)
 ROM_CALL HeapFree ;remove handle in case of error
 bra skiproot
skiplogy2:
 move.w d3,(a7)
 ROM_CALL HeapFree ;remove handle in case of error
 bra skiplogy
nomem:
 addq.l #2,a7 ;adjust the stack
 pea.l nomemST(PC) ;show "no mem" message
 bra showmsg

;word-aligned data here
event: ;event structure for EV_sendEvent
 dc.w $710 ;type = CM_STRING
 ds.b 6 ;RunningApp (2), Side (2), StatusFlags (2)
event_key:
 dc.w $0,$116,0 ;Mod, Code, StartType (2)

newevent89: ;event hook for TI-89
 dc.b 'evHkXtraKeys' ;signature "evHk" + program name
                     ;(for event hook uninstaller)
oldevent89: dc.l 0 ;placeholder for old event hook
                   ;0 if none
                   ;placed here for easier and
                   ;program- and version-independent
                   ;uninstalling
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 move.l 64(a7),a2 ;a2=event structure address (a2 for TEOS)
 cmp.w #$700,(a2) ;check if CM_IDLE or CM_BLINK
 beq idle89
 cmp.w #$740,(a2)
 bne notidle89
idle89:
 lea.l statusflags89(PC),a0 ;if yes, save the status flags
 move.w (a0),2(a0)
 move.w 6(a2),(a0)
notidle89:
 cmp.w #$710,(a2) ;check if CM_KEYPRESS
 bne notkeypress89 ;if not, do nothing
 move.w 10(a2),d5 ;d5 = keycode
 move.b accenttype89(PC),d1 ;d1 = accent type
 tst.b d1 ;check if there is an accent
 beq noaccent89 ;if not, skip
 cmp.w #'a',d5 ;check if a
 bne notminusa89
 cmp.b #1,d1 ;check if acute accent
 bne minusanotacute89
 move.w #225,10(a2) ;change key code to ""
 bra endaccent89
minusanotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusanotgrave89
 move.w #224,10(a2) ;change key code to ""
 bra endaccent89
minusanotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusanotcircumflex89
 move.w #226,10(a2) ;change key code to ""
 bra endaccent89
minusanotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne minusanottrema89
 move.w #228,10(a2) ;change key code to ""
 bra endaccent89
minusanottrema89:
 move.w #227,10(a2) ;change key code to ""
 bra endaccent89
notminusa89:
 cmp.w #'e',d5 ;check if e
 bne notminuse89
 cmp.b #1,d1 ;check if acute accent
 bne minusenotacute89
 move.w #233,10(a2) ;change key code to ""
 bra endaccent89
minusenotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusenotgrave89
 move.w #232,10(a2) ;change key code to ""
 bra endaccent89
minusenotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusenotcircumflex89
 move.w #234,10(a2) ;change key code to ""
 bra endaccent89
minusenotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #235,10(a2) ;change key code to ""
 bra endaccent89
notminuse89:
 cmp.w #'i',d5 ;check if i
 bne notminusi89
 cmp.b #1,d1 ;check if acute accent
 bne minusinotacute89
 move.w #237,10(a2) ;change key code to ""
 bra endaccent89
minusinotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusinotgrave89
 move.w #236,10(a2) ;change key code to ""
 bra endaccent89
minusinotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusinotcircumflex89
 move.w #238,10(a2) ;change key code to ""
 bra endaccent89
minusinotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #239,10(a2) ;change key code to ""
 bra endaccent89
notminusi89:
 cmp.w #'o',d5 ;check if o
 bne notminuso89
 cmp.b #1,d1 ;check if acute accent
 bne minusonotacute89
 move.w #243,10(a2) ;change key code to ""
 bra endaccent89
minusonotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusonotgrave89
 move.w #242,10(a2) ;change key code to ""
 bra endaccent89
minusonotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusonotcircumflex89
 move.w #244,10(a2) ;change key code to ""
 bra endaccent89
minusonotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne minusonottrema89
 move.w #246,10(a2) ;change key code to ""
 bra endaccent89
minusonottrema89:
 move.w #245,10(a2) ;change key code to ""
 bra endaccent89
notminuso89:
 cmp.w #'u',d5 ;check if u
 bne notminusu89
 cmp.b #1,d1 ;check if acute accent
 bne minusunotacute89
 move.w #250,10(a2) ;change key code to ""
 bra endaccent89
minusunotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne minusunotgrave89
 move.w #249,10(a2) ;change key code to ""
 bra endaccent89
minusunotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne minusunotcircumflex89
 move.w #251,10(a2) ;change key code to ""
 bra endaccent89
minusunotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #252,10(a2) ;change key code to ""
 bra endaccent89
notminusu89:
 cmp.w #'y',d5 ;check if y
 bne notminusy89
 cmp.b #1,d1 ;check if acute accent
 bne minusynotacute89
 move.w #253,10(a2) ;change key code to ""
 bra endaccent89
minusynotacute89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #255,10(a2) ;change key code to ""
 bra endaccent89
notminusy89:
 cmp.w #'n',d5 ;check if n
 bne notminusn89
 cmp.b #5,d1 ;check if tilde
 bne invalidaccent89
 move.w #241,10(a2) ;change key code to ""
 bra endaccent89  
notminusn89:
 cmp.w #'A',d5 ;check if A
 bne notcapsa89
 cmp.b #1,d1 ;check if acute accent
 bne capsanotacute89
 move.w #193,10(a2) ;change key code to ""
 bra endaccent89
capsanotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsanotgrave89
 move.w #192,10(a2) ;change key code to ""
 bra endaccent89
capsanotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsanotcircumflex89
 move.w #194,10(a2) ;change key code to ""
 bra endaccent89
capsanotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne capsanottrema89
 move.w #196,10(a2) ;change key code to ""
 bra endaccent89
capsanottrema89:
 move.w #195,10(a2) ;change key code to ""
 bra endaccent89
notcapsa89:
 cmp.w #'E',d5 ;check if E
 bne notcapse89
 cmp.b #1,d1 ;check if acute accent
 bne capsenotacute89
 move.w #201,10(a2) ;change key code to ""
 bra endaccent89
capsenotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsenotgrave89
 move.w #200,10(a2) ;change key code to ""
 bra endaccent89
capsenotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsenotcircumflex89
 move.w #202,10(a2) ;change key code to ""
 bra endaccent89
capsenotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #203,10(a2) ;change key code to ""
 bra endaccent89
notcapse89:
 cmp.w #'I',d5 ;check if I
 bne notcapsi89
 cmp.b #1,d1 ;check if acute accent
 bne capsinotacute89
 move.w #205,10(a2) ;change key code to ""
 bra endaccent89
capsinotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsinotgrave89
 move.w #204,10(a2) ;change key code to ""
 bra endaccent89
capsinotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsinotcircumflex89
 move.w #206,10(a2) ;change key code to ""
 bra endaccent89
capsinotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #207,10(a2) ;change key code to ""
 bra endaccent89
notcapsi89:
 cmp.w #'O',d5 ;check if O
 bne notcapso89
 cmp.b #1,d1 ;check if acute accent
 bne capsonotacute89
 move.w #211,10(a2) ;change key code to ""
 bra endaccent89
capsonotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsonotgrave89
 move.w #210,10(a2) ;change key code to ""
 bra endaccent89
capsonotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsonotcircumflex89
 move.w #212,10(a2) ;change key code to ""
 bra endaccent89
capsonotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne capsonottrema89
 move.w #214,10(a2) ;change key code to ""
 bra endaccent89
capsonottrema89:
 move.w #213,10(a2) ;change key code to ""
 bra endaccent89
notcapso89:
 cmp.w #'U',d5 ;check if U
 bne notcapsu89
 cmp.b #1,d1 ;check if acute accent
 bne capsunotacute89
 move.w #218,10(a2) ;change key code to ""
 bra endaccent89
capsunotacute89:
 cmp.b #2,d1 ;check if grave accent
 bne capsunotgrave89
 move.w #217,10(a2) ;change key code to ""
 bra endaccent89
capsunotgrave89:
 cmp.b #3,d1 ;check if circumflex accent
 bne capsunotcircumflex89
 move.w #219,10(a2) ;change key code to ""
 bra endaccent89
capsunotcircumflex89:
 cmp.b #4,d1 ;check if trema
 bne invalidaccent89
 move.w #220,10(a2) ;change key code to ""
 bra endaccent89
notcapsu89:
 cmp.w #'Y',d5 ;check if Y
 bne notcapsy89
 cmp.b #1,d1 ;check if acute accent
 bne invalidaccent89
 move.w #221,10(a2) ;change key code to ""
 bra endaccent89
notcapsy89:
 cmp.w #'N',d5 ;check if N
 bne notcapsn89
 cmp.b #5,d1 ;check if tilde
 bne invalidaccent89
 move.w #209,10(a2) ;change key code to ""
 bra endaccent89  
notcapsn89:
invalidaccent89:
 move.w #$700,(a2) ;change event to CM_IDLE
endaccent89:
 lea.l accenttype89(PC),a0
 clr.b (a0) ;delete accent
 bra notkeypress89 ;do nothing more
noaccent89:
 ROM_CALL2 FirstWindow
 move.l (a4),a4
 cmp.l catalog89(PC),a4 ;check if the catalog is active
 beq notkeypress89 ;if yes, don't interfere with it
;"rowread" routine
 move.w #$700,-(a7)
 ROM_CALL OSSetSR ;disable interrupts
 move.w #$fe,$600018 ;read the keyboard directly to get the
 nop                 ;info TI's event stucture doesn't give
 nop                 ;out (The key modifiers are not given
 nop                 ;if we need them, only if we don't
 nop                 ;need them. Don't ask me why.)
 nop
 nop
 nop
 nop
 nop
 nop
 nop ;The return value is automatically put in $60001b by
 nop ;the hardware.
 move.b $60001b,d3 ;save the result of rowread to d3
 clr.w (a7)
 ROM_CALL OSSetSR ;reenable interrupts
 addq.l #2,a7
 move.w statusflags289(PC),d1 ;d1 = status flags
 cmp.w #$107,d5 ;check if CLEAR
 bne notclear89
 btst.l #0,d1 ;check if sequential 2nd+CLEAR
 bne clear2nd89
 btst.b #4,d3 ;check if simultaneous 2nd+CLEAR
 bne notclear89
clear2nd89:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simpleinv89
 move.l params89(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simpleinv89
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq ansinv89
 btst.b #5,17(a3)
 beq simpleinv89
 tst.w 6(a3)
 bne notbeginning189
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simpleinv89
 bra ansinv89
notbeginning189:
 tst.w 2(a3)
 bne simpleinv89
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simpleinv89
ansinv89:
 move.l #$1000b,-(a7)
 pea.l ans1tag89(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simpleinv89 ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
ansinvnext89: ;add ^-1 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne ansinvnext89
 move.b #'^',(a1)+
 move.b #173,(a1)+
 move.b #'1',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress89 ;do nothing more
simpleinv89:
 lea.l txt_inv89(PC),a0 ;insert ^-1
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notclear89:
 cmp.w #$115,d5 ;check if HOME
 bne nothome89
 btst.l #2,d1 ;check if sequential DIAMOND+HOME
 bne homediam89
 btst.b #6,d3 ;check if simultaneous DIAMOND+HOME
 bne nothomed89
homediam89:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_10exp89(PC),a0 ;insert 10^(
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
nothomed89:
 btst.l #1,d1 ;check if sequential SHIFT+HOME
 bne homeshift89
 btst.l #4,d1 ;check if CAPS lock+HOME
 bne homeshift89
 btst.b #5,d3 ;check if simultaneous SHIFT+HOME
 bne nothome89
homeshift89:
 lea.l accenttype89(PC),a0
 move.b #5,(a0) ;tilde
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
nothome89:
 cmp.w #$4107,d5 ;check if DIAMOND+CLEAR
 bne notdiamclear89
 move.l #$1000a,-(a7)
 pea.l logtag89(PC)
 ROM_CALL Parse1DExpr ;convert log to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress89 ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
lognext89:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne lognext89
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 lea.l event_string89(PC),a0 ;insert the address of the log( string into the
 move.l a3,(a0)              ;placeholder in the event structure
 pea.l event89(PC)
 move.w #-2,-(a7)
 ROM_CALL EV_sendEvent ;send the CM_STRING event to the current application
 addq.l #6,a7 ;We have to send an additional event because we have to keep the
              ;self-test key working.
 bra notkeypress89 ;do nothing more
notdiamclear89:
 cmp.w #$10c,d5 ;check if F1
 bne notf189
 btst.l #1,d1 ;check if sequential SHIFT+F1
 bne f1shift89
 btst.l #4,d1 ;check if CAPS lock+F1
 bne f1shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F1
 bne notf1s89
f1shift89:
 move.l #3000,-(a7)
 ROM_CALL HeapAllocPtr
 move.l a0,d4 ;save the address to d4
 tst.l d4
 beq f1shiftnomem89 ;if NULL pointer, don't display key map
 move.l #$4c00,-(a7)
 move.l d4,-(a7)
 ROM_CALL memcpy ;save the screen
 addq.l #6,a7
 move.w #4,(a7)
 pea.l keymapclip89(PC)
 pea.l keymap89(PC)
 clr.l -(a7)
 ROM_CALL BitmapPut ;display the key map
 lea.l 10(a7),a7
 ROM_CALL ngetchx ;wait for a keypress
 move.l d4,(a7)
 move.l #$4c00,-(a7)
 ROM_CALL memcpy ;restore the screen
 addq.l #4,a7
 ROM_CALL HeapFreePtr
 addq.l #4,a7
f1shiftnomem89:
 addq.l #4,a7
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf1s89:
 btst.l #3,d1 ;check if sequential alpha+F1
 bne f1alpha89
 btst.l #5,d1 ;check if alpha lock+F1
 bne f1alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F1
 bne notf189
f1alpha89:
 lea.l accenttype89(PC),a0
 move.b #1,(a0) ;acute accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf189:
 cmp.w #$10d,d5 ;check if F2
 bne notf289
 btst.l #1,d1 ;check if sequential SHIFT+F2
 bne f2shift89
 btst.l #4,d1 ;check if CAPS lock+F2
 bne f2shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F2
 bne notf2s89
f2shift89:
 move.l #$1000a,-(a7)
 pea.l abstag89(PC)
 ROM_CALL Parse1DExpr ;convert abs to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress89 ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
absnext89:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne absnext89
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert abs(
 bra notkeypress89 ;do nothing more
notf2s89:
 btst.l #3,d1 ;check if sequential alpha+F2
 bne f2alpha89
 btst.l #5,d1 ;check if alpha lock+F2
 bne f2alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F2
 bne notf289
f2alpha89:
 lea.l accenttype89(PC),a0
 move.b #2,(a0) ;grave accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf289:
 cmp.w #$10e,d5 ;check if F3
 bne notf389
 btst.l #1,d1 ;check if sequential SHIFT+F3
 bne f3shift89
 btst.l #4,d1 ;check if CAPS lock+F3
 bne f3shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F3
 bne notf3s89
f3shift89:
 move.l #$1000a,-(a7)
 pea.l ncrtag89(PC)
 ROM_CALL Parse1DExpr ;convert nCr to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress89 ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
ncrnext89:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne ncrnext89
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert nCr(
 bra notkeypress89 ;do nothing more
notf3s89:
 btst.l #3,d1 ;check if sequential alpha+F3
 bne f3alpha89
 btst.l #5,d1 ;check if alpha lock+F3
 bne f3alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F3
 bne notf389
f3alpha89:
 lea.l accenttype89(PC),a0
 move.b #3,(a0) ;circumflex accent
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf389:
 cmp.w #$10f,d5 ;check if F4
 bne notf489
 btst.l #0,d1 ;check if sequential 2nd+F4
 bne f42nd89
 btst.b #4,d3 ;check if simultaneous 2nd+F4
 bne notf4289
f42nd89:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplesquare89
 move.l params89(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplesquare89
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anssquare89
 btst.b #5,17(a3)
 beq simplesquare89
 tst.w 6(a3)
 bne notbeginning289
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplesquare89
 bra anssquare89
notbeginning289:
 tst.w 2(a3)
 bne simplesquare89
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplesquare89
anssquare89:
 move.l #$1000b,-(a7)
 pea.l ans1tag89(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simplesquare89 ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
anssquarenext89: ;add ^2 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anssquarenext89
 move.b #'^',(a1)+
 move.b #'2',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress89 ;do nothing more
simplesquare89:
 lea.l txt_square89(PC),a0 ;insert ^2
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notf4289:
 btst.l #1,d1 ;check if sequential SHIFT+F4
 bne f4shift89
 btst.l #4,d1 ;check if CAPS lock+F4
 bne f4shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F4
 bne notf4s89
f4shift89:
 move.l #$1000a,-(a7)
 pea.l nprtag89(PC)
 ROM_CALL Parse1DExpr ;convert nPr to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress89 ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
nprnext89:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne nprnext89
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert nPr(
 bra notkeypress89 ;do nothing more
notf4s89:
 btst.l #3,d1 ;check if sequential alpha+F4
 bne f4alpha89
 btst.l #5,d1 ;check if alpha lock+F4
 bne f4alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F4
 bne notf489
f4alpha89:
 lea.l accenttype89(PC),a0
 move.b #4,(a0) ;trema or german Umlaut
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress89 ;do nothing more
notf489:
 cmp.w #$110,d5 ;check if F5
 bne notf589
 btst.l #0,d1 ;check if sequential 2nd+F5
 bne f52nd89
 btst.b #4,d3 ;check if simultaneous 2nd+F5
 bne notf5289
f52nd89:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window89(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplecube89
 move.l params89(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplecube89
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anscube89
 btst.b #5,17(a3)
 beq simplecube89
 tst.w 6(a3)
 bne notbeginning389
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplecube89
 bra anscube89
notbeginning389:
 tst.w 2(a3)
 bne simplecube89
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplecube89
anscube89:
 move.l #$1000b,-(a7)
 pea.l ans1tag89(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simplecube89 ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer89(PC),a1
 move.l a1,a3
anscubenext89: ;add ^3 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anscubenext89
 move.b #'^',(a1)+
 move.b #'3',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress89 ;do nothing more
simplecube89:
 lea.l txt_cube89(PC),a0 ;insert ^3
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notf5289:
 btst.l #1,d1 ;check if sequential SHIFT+F5
 bne f5shift89
 btst.l #4,d1 ;check if CAPS lock+F5
 bne f5shift89
 btst.b #5,d3 ;check if simultaneous SHIFT+F5
 bne notf5s89
f5shift89:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_sigma89(PC),a0 ;insert SIGMA(
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notf5s89:
 btst.l #3,d1 ;check if sequential alpha+F5
 bne f5alpha89
 btst.l #5,d1 ;check if alpha lock+F5
 bne f5alpha89
 btst.b #7,d3 ;check if simultaneous alpha+F5
 bne notf589
f5alpha89:
 move.w #223,10(a2) ;change key code to german sz
 bra notkeypress89 ;do nothing more
notf589:
 cmp.w #$5e,d5 ;check if ^
 bne notpower89
 btst.l #1,d1 ;check if sequential SHIFT+^
 bne powershift89
 btst.l #4,d1 ;check if CAPS lock+^
 bne powershift89
 btst.b #5,d3 ;check if simultaneous SHIFT+^
 bne notpowers89
powershift89:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_xlog89(PC),a0 ;insert x\logy(
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notpowers89:
 btst.l #3,d1 ;check if sequential alpha+^
 bne poweralpha89
 btst.l #5,d1 ;check if alpha lock+^
 bne poweralpha89
 btst.b #7,d3 ;check if simultaneous alpha+^
 bne notpower89
poweralpha89:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_xroot89(PC),a0 ;insert x\root(
 move.l a0,8(a2)
 bra notkeypress89 ;do nothing more
notpower89:
 cmp.w #$10a,d5 ;check if MODE
 bne notmode89
 btst.l #1,d1 ;check if sequential SHIFT+MODE
 bne modeshift89
 btst.l #4,d1 ;check if CAPS lock+MODE
 bne modeshift89
 btst.b #5,d3 ;check if simultaneous SHIFT+MODE
 bne notmodes89
modeshift89:
 move.w #'#',10(a2) ;change key code to "#"
 bra notkeypress89 ;do nothing more
notmodes89:
 btst.l #3,d1 ;check if sequential alpha+MODE
 bne modealpha89
 btst.l #5,d1 ;check if alpha lock+MODE
 bne modealpha89
 btst.b #7,d3 ;check if simultaneous alpha+MODE
 bne notmode89
modealpha89:
 move.w #'?',10(a2) ;change key code to "?"
 bra notkeypress89 ;do nothing more
notmode89:
 cmp.w #$109,d5 ;check if APPS
 bne notapps89
 btst.l #1,d1 ;check if sequential SHIFT+APPS
 bne appsshift89
 btst.l #4,d1 ;check if CAPS lock+APPS
 bne appsshift89
 btst.b #5,d3 ;check if simultaneous SHIFT+APPS
 bne notappss89
appsshift89:
 move.w #199,10(a2) ;change key code to C cedilla
 bra notkeypress89 ;do nothing more
notappss89:
 btst.l #3,d1 ;check if sequential alpha+APPS
 bne appsalpha89
 btst.l #5,d1 ;check if alpha lock+APPS
 bne appsalpha89
 btst.b #7,d3 ;check if simultaneous alpha+APPS
 bne notapps89
appsalpha89:
 move.w #231,10(a2) ;change key code to c cedilla
 bra notkeypress89 ;do nothing more
notapps89:
 cmp.w #$116,d5 ;check if CATALOG
 bne notkeypress89
 btst.l #1,d1 ;check if sequential SHIFT+CATALOG
 bne catalogshift89
 btst.l #4,d1 ;check if CAPS lock+CATALOG
 bne catalogshift89
 btst.b #5,d3 ;check if simultaneous SHIFT+CATALOG
 bne notkeypress89
catalogshift89:
 move.w #150,10(a2) ;change key code to Napier/Euler e
notkeypress89:
 move.l oldevent89(PC),a0 ;a0 = old event hook
 cmp.l #0,a0 ;check if 0 (tst refuses this addressing mode)
 beq nooldevent89 ;if 0 do nothing
 move.l a2,-(a7) ;pass event structure as an argument
 jsr (a0) ;run the old event hook
 addq.l #4,a7
nooldevent89:
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)
statusflags89: dc.w 0 ;placeholder for the status flags
statusflags289: dc.w 0
params89: dc.l $6016 ;position of the home screen entry line
                     ;parameters
window89: dc.l $6071 ;position of the 2nd byte of the home
                     ;screen window flags (containing the
                     ;"active" flag)
catalog89: dc.l 0 ;position of the catalog window flags
;Those values may be adjusted for different AMS versions.
event89: ;event structure for EV_sendEvent
 dc.w $723 ;type = CM_STRING
 ds.b 6 ;RunningApp (2), Side (2), StatusFlags (2)
event_string89:
 ds.b 6 ;pasteText (4), StartType (2)
keymapclip89: dc.b 0,0,159,99
keymap89:
 dc.w 100,160
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $39,$81,$5d,$4c,$3b,$80,$00,$80,$39,$00,$00,$60,$11,$00,$00,$c0,$13,$00,$00,$3c
 dc.b $22,$01,$51,$50,$20,$80,$06,$cc,$22,$80,$00,$80,$2a,$80,$00,$a0,$28,$80,$00,$10
 dc.b $33,$01,$98,$88,$30,$80,$0a,$a8,$31,$00,$0c,$8c,$00,$80,$0c,$cc,$03,$00,$00,$08
 dc.b $22,$81,$50,$84,$21,$00,$0a,$a4,$22,$80,$0a,$88,$01,$00,$0a,$88,$00,$80,$00,$10
 dc.b $21,$01,$5c,$98,$22,$00,$06,$cc,$21,$00,$0a,$68,$03,$80,$0a,$88,$03,$00,$00,$3c
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$04,$00,$00,$00,$08,$00,$00,$00,$08,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$08,$00,$00,$00,$04,$00,$00,$00,$14,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $28,$00,$00,$00,$2a,$96,$54,$00,$1b,$13,$28,$00,$3a,$26,$08,$14,$39,$32,$38,$18
 dc.b $2b,$80,$00,$08,$2a,$d5,$54,$0c,$22,$aa,$a8,$08,$12,$28,$48,$00,$12,$aa,$20,$24
 dc.b $10,$00,$00,$14,$2a,$f5,$54,$14,$2b,$3b,$38,$14,$13,$24,$ac,$14,$13,$b2,$30,$28
 dc.b $13,$80,$00,$18,$2a,$b5,$54,$14,$2a,$aa,$28,$14,$12,$a2,$c8,$14,$12,$aa,$20,$24
 dc.b $10,$00,$00,$0c,$14,$96,$28,$0c,$12,$aa,$28,$08,$13,$2c,$6c,$1c,$12,$b3,$b8,$28
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38
 dc.b $20,$0e,$10,$04,$20,$0e,$60,$04,$20,$0e,$60,$04,$20,$0e,$50,$04,$20,$0e,$f0,$04
 dc.b $40,$08,$30,$02,$40,$08,$90,$02,$40,$08,$10,$02,$40,$08,$50,$02,$40,$08,$80,$02
 dc.b $40,$08,$50,$02,$40,$08,$10,$02,$40,$08,$60,$02,$40,$08,$90,$02,$40,$08,$e0,$02
 dc.b $40,$0e,$10,$02,$40,$0e,$20,$02,$40,$0e,$10,$02,$40,$0e,$f0,$02,$40,$0e,$10,$02
 dc.b $40,$08,$10,$02,$40,$08,$40,$02,$40,$08,$10,$02,$40,$08,$10,$02,$40,$08,$10,$02
 dc.b $20,$08,$10,$04,$20,$08,$f0,$04,$20,$08,$60,$04,$20,$08,$10,$04,$20,$08,$e0,$04
 dc.b $1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38,$1c,$00,$00,$38
 dc.b $03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0,$03,$ff,$ff,$c0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$7f,$c0,$00,$00,$00,$0f,$ff,$c0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$3f,$ff,$c0,$0c,$00,$00,$70,$00,$38,$00,$00,$00
 dc.b $ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$20,$60,$c0,$10,$00,$03,$80,$f8,$07,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$22,$68,$c0,$10,$00,$1c,$03,$06,$00,$e0,$00,$00
 dc.b $00,$00,$80,$00,$00,$21,$00,$00,$27,$fc,$c0,$10,$00,$e0,$04,$21,$00,$1c,$00,$00
 dc.b $03,$39,$80,$00,$00,$71,$00,$00,$22,$68,$c0,$0c,$03,$00,$08,$70,$80,$02,$00,$00
 dc.b $04,$aa,$80,$00,$00,$f9,$00,$00,$20,$60,$c0,$08,$04,$70,$08,$f8,$80,$71,$80,$00
 dc.b $20,$a9,$00,$00,$09,$fd,$00,$00,$3f,$ff,$c0,$10,$08,$88,$09,$fc,$80,$88,$40,$00
 dc.b $71,$00,$00,$00,$1c,$71,$00,$00,$00,$7f,$c0,$00,$09,$04,$04,$01,$01,$04,$40,$00
 dc.b $22,$00,$00,$00,$08,$71,$00,$00,$00,$00,$00,$00,$11,$14,$03,$06,$01,$44,$20,$00
 dc.b $07,$80,$00,$00,$00,$71,$00,$00,$3a,$11,$a8,$1c,$12,$32,$00,$f8,$02,$62,$20,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$22,$2a,$28,$10,$12,$72,$00,$00,$02,$72,$20,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$32,$39,$38,$1c,$12,$f2,$00,$00,$02,$7a,$20,$00
 dc.b $01,$00,$00,$00,$00,$01,$00,$00,$22,$28,$a8,$08,$12,$72,$00,$00,$02,$72,$20,$00
 dc.b $03,$80,$00,$00,$41,$01,$00,$00,$23,$ab,$28,$10,$12,$32,$00,$f8,$02,$62,$20,$00
 dc.b $27,$c0,$00,$20,$41,$01,$00,$00,$00,$00,$00,$00,$11,$14,$03,$06,$01,$44,$20,$00
 dc.b $77,$c0,$00,$73,$59,$8d,$00,$00,$01,$ff,$ff,$80,$09,$04,$04,$01,$01,$04,$40,$00
 dc.b $23,$80,$00,$25,$55,$55,$00,$00,$06,$00,$00,$60,$08,$88,$09,$fc,$80,$88,$40,$00
 dc.b $01,$00,$00,$03,$59,$4d,$00,$00,$08,$00,$00,$10,$04,$70,$08,$f8,$80,$71,$80,$00
 dc.b $00,$00,$00,$00,$10,$01,$00,$00,$10,$00,$00,$08,$03,$00,$08,$70,$80,$02,$00,$00
 dc.b $00,$00,$00,$00,$10,$01,$00,$00,$20,$00,$00,$04,$00,$e0,$04,$21,$00,$1c,$00,$00
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$20,$00,$00,$04,$00,$1c,$03,$06,$00,$e0,$00,$00
 dc.b $03,$ff,$ff,$ff,$ff,$81,$00,$00,$40,$8e,$71,$c2,$00,$03,$80,$f8,$07,$00,$00,$00
 dc.b $0f,$ff,$ff,$ff,$ff,$e1,$00,$00,$41,$49,$4a,$22,$00,$00,$70,$00,$38,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$f1,$00,$00,$41,$49,$4a,$02,$00,$00,$0f,$ff,$c0,$00,$00,$00
 dc.b $3f,$ff,$a8,$af,$ff,$f9,$00,$00,$42,$2e,$71,$c2,$00,$00,$00,$00,$10,$10,$0d,$1c
 dc.b $7f,$ff,$ab,$af,$ff,$fd,$00,$00,$43,$e8,$40,$22,$00,$00,$00,$00,$28,$30,$11,$14
 dc.b $7f,$ff,$99,$df,$ff,$fd,$00,$00,$42,$28,$40,$22,$00,$00,$00,$00,$03,$50,$11,$18
 dc.b $7f,$ff,$ab,$df,$ff,$fd,$00,$00,$42,$28,$42,$22,$00,$00,$00,$00,$00,$10,$11,$14
 dc.b $3f,$ff,$a8,$df,$ff,$f9,$00,$00,$42,$28,$41,$c2,$00,$00,$00,$00,$00,$10,$0d,$d4
 dc.b $1f,$ff,$ff,$ff,$ff,$f1,$00,$00,$20,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0f,$ff,$ff,$ff,$ff,$e1,$00,$00,$20,$00,$00,$04,$00,$00,$00,$00,$20,$60,$0d,$1c
 dc.b $03,$ff,$ff,$ff,$ff,$81,$00,$00,$10,$00,$00,$08,$00,$00,$00,$00,$24,$a0,$11,$14
 dc.b $00,$00,$00,$00,$00,$01,$00,$00,$08,$00,$00,$10,$00,$00,$00,$00,$2a,$60,$11,$18
 dc.b $ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$06,$00,$00,$60,$00,$00,$00,$00,$2a,$20,$11,$14
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$01,$ff,$ff,$80,$00,$00,$00,$00,$24,$c0,$0d,$d4
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $33,$74,$40,$0a,$01,$00,$02,$40,$02,$00,$00,$60,$05,$13,$02,$00,$03,$ff,$ff,$c0
 dc.b $44,$26,$c0,$14,$01,$80,$07,$e0,$00,$00,$00,$90,$05,$94,$06,$00,$1c,$00,$00,$38
 dc.b $42,$25,$40,$00,$01,$c0,$02,$40,$02,$00,$01,$e0,$05,$52,$0f,$e0,$20,$00,$00,$04
 dc.b $41,$24,$40,$18,$01,$80,$07,$e0,$02,$00,$01,$00,$05,$31,$06,$00,$43,$47,$99,$c2
 dc.b $36,$24,$40,$14,$01,$00,$02,$40,$01,$00,$00,$c0,$05,$16,$02,$00,$44,$44,$25,$22
 dc.b $00,$00,$00,$14,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$44,$44,$25,$22
 dc.b $00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,$00,$00,$44,$47,$3d,$c2
 dc.b $12,$22,$ba,$2e,$00,$00,$02,$40,$02,$80,$32,$70,$06,$74,$02,$00,$44,$44,$25,$42
 dc.b $35,$52,$ab,$68,$00,$00,$00,$80,$05,$40,$45,$20,$05,$44,$06,$00,$44,$44,$25,$22
 dc.b $55,$03,$aa,$ac,$00,$00,$00,$80,$05,$40,$47,$20,$05,$64,$0f,$e0,$43,$77,$a5,$22
 dc.b $15,$02,$aa,$28,$00,$00,$00,$00,$02,$80,$45,$20,$05,$44,$06,$00,$20,$00,$00,$04
 dc.b $12,$02,$ba,$2e,$01,$e0,$00,$80,$00,$00,$35,$20,$06,$77,$02,$00,$1c,$00,$00,$38
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $01,$ff,$ff,$80,$01,$ff,$ff,$80,$01,$ff,$ff,$80,$01,$ff,$ff,$80,$00,$00,$02,$06
 dc.b $06,$00,$00,$60,$06,$00,$00,$60,$06,$00,$00,$60,$06,$00,$00,$60,$00,$00,$02,$4a
 dc.b $08,$00,$00,$10,$08,$00,$00,$10,$08,$00,$00,$10,$08,$00,$00,$10,$0f,$80,$02,$a6
 dc.b $10,$00,$00,$08,$10,$00,$00,$08,$10,$00,$00,$08,$10,$00,$00,$08,$05,$00,$2a,$a2
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$05,$00,$12,$4c
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$00,$00,$28,$00
 dc.b $44,$44,$45,$e2,$44,$44,$71,$e2,$4c,$9c,$91,$12,$40,$20,$00,$02,$00,$00,$00,$00
 dc.b $44,$4a,$6d,$02,$46,$ca,$49,$02,$49,$49,$52,$a2,$40,$60,$00,$02,$02,$00,$14,$3c
 dc.b $44,$51,$6d,$02,$46,$d1,$45,$02,$49,$49,$52,$a2,$40,$e0,$00,$02,$05,$00,$08,$20
 dc.b $47,$d1,$55,$c2,$45,$51,$45,$c2,$49,$c9,$d2,$ba,$41,$ff,$ff,$82,$07,$00,$14,$40
 dc.b $44,$51,$55,$02,$45,$51,$45,$02,$49,$49,$52,$aa,$40,$e0,$00,$02,$05,$00,$01,$40
 dc.b $44,$51,$45,$02,$44,$51,$45,$02,$49,$49,$52,$aa,$40,$60,$00,$02,$02,$00,$00,$80
 dc.b $44,$4a,$45,$02,$44,$4a,$49,$02,$4d,$49,$59,$12,$40,$20,$00,$02,$00,$00,$00,$00
 dc.b $44,$44,$45,$e2,$44,$44,$71,$e2,$40,$00,$00,$02,$40,$00,$00,$02,$03,$ff,$ff,$c0
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$1c,$00,$00,$38
 dc.b $20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$00,$00,$04,$20,$01,$00,$04
 dc.b $10,$00,$00,$08,$10,$00,$00,$08,$10,$00,$00,$08,$10,$00,$00,$08,$40,$02,$80,$02
 dc.b $08,$00,$00,$10,$08,$00,$00,$10,$08,$00,$00,$10,$08,$00,$00,$10,$40,$04,$40,$02
 dc.b $06,$00,$00,$60,$06,$00,$00,$60,$06,$00,$00,$60,$06,$00,$00,$60,$40,$00,$00,$02
 dc.b $01,$ff,$ff,$80,$01,$ff,$ff,$80,$01,$ff,$ff,$80,$01,$ff,$ff,$80,$20,$00,$00,$04
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1c,$00,$00,$38
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$ff,$ff,$c0
accenttype89: dc.b 0 ;type of the selected accent
txt_inv89: dc.b '^',173,'1',0
txt_10exp89: dc.b '10^(',0
txt_square89: dc.b '^2',0
txt_cube89: dc.b '^3',0
txt_xroot89: dc.b 'x\root(',0
txt_xlog89: dc.b 'x\logy(',0
txt_sigma89: dc.b 142,'(',0
 dc.b $08 ;tokenized expressions for localization support
abstag89: dc.b $4b
 dc.b $08
logtag89: dc.b $54
 dc.b $09,$08
ncrtag89: dc.b $a7
 dc.b $09,$08
nprtag89: dc.b $a8
 dc.b $e5,$01,$01,$1f
ans1tag89: dc.b $bc
funcbuffer89: ds.b 15
endevent89:

 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)

newevent92p: ;event hook for TI-92+
 dc.b 'evHkXtraKeys' ;signature "evHk" + program name
                      ;(for event hook uninstaller)
oldevent92p: dc.l 0 ;placeholder for old event hook
                    ;0 if none
                    ;placed here for easier and
                    ;program- and version-independent
                    ;uninstalling
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 move.l 64(a7),a2 ;a2=event structure address (a2 for TEOS)
 cmp.w #$700,(a2) ;check if CM_IDLE or CM_BLINK
 beq idle92p
 cmp.w #$740,(a2)
 bne notidle92p
idle92p:
 lea.l statusflags92p(PC),a0 ;if yes, save the status flags
 move.w (a0),2(a0)
 move.w 6(a2),(a0)
notidle92p:
 cmp.w #$710,(a2) ;check if CM_KEYPRESS
 bne notkeypress92p ;if not, do nothing
 move.w #$700,-(a7)
 ROM_CALL OSSetSR ;disable interrupts
;"rowread" routine
 move.w #$fe,$600018 ;read the keyboard directly to get the
 nop                 ;info TI's event stucture doesn't give
 nop                 ;out (The key modifiers are not given
 nop                 ;if we need them, only if we don't
 nop                 ;need them. Don't ask me why.)
 nop
 nop
 nop
 nop ;The return value is automatically put in $60001b by
 nop ;the hardware.
 move.w 10(a2),d5 ;d5 = keycode
;I'm putting this here to reduce the number of needed NOPs
;from 12 to 9.
 move.b $60001b,d3 ;save the result of rowread to d3
 clr.w (a7)
 ROM_CALL OSSetSR ;reenable interrupts
 addq.l #2,a7
 move.w statusflags292p(PC),d1 ;d1 = status flags
 cmp.w #$107,d5 ;check if CLEAR
 bne notclear92p
 btst.l #0,d1 ;check if sequential 2nd+CLEAR
 bne clear2nd92p
 btst.b #0,d3 ;check if simultaneous 2nd+CLEAR
 bne notclear92p
clear2nd92p:
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_10exp92p(PC),a0 ;insert 10^(
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notclear92p:
 cmp.w #$2107,d5 ;check if DIAMOND+CLEAR
 bne notdiamclear92p
 move.l #$1000a,-(a7)
 pea.l logtag92p(PC)
 ROM_CALL Parse1DExpr ;convert log to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress92p ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
lognext92p:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne lognext92p
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert log(
 bra notkeypress92p ;do nothing more
notdiamclear92p:
 cmp.w #$10a,d5 ;check if MODE
 bne notmode92p
 btst.l #0,d1 ;check if sequential 2nd+MODE
 bne mode2nd92p
 btst.b #0,d3 ;check if simultaneous 2nd+MODE
 bne notmode92p
mode2nd92p:
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window92p(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplesquare92p
 move.l params92p(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplesquare92p
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anssquare92p
 btst.b #5,17(a3)
 beq simplesquare92p
 tst.w 6(a3)
 bne notbeginning292p
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplesquare92p
 bra anssquare92p
notbeginning292p:
 tst.w 2(a3)
 bne simplesquare92p
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplesquare92p
anssquare92p:
 move.l #$1000b,-(a7)
 pea.l ans1tag92p(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simplesquare92p ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
anssquarenext92p: ;add ^2 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anssquarenext92p
 move.b #'^',(a1)+
 move.b #'2',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress92p ;do nothing more
simplesquare92p:
 lea.l txt_square92p(PC),a0 ;insert ^2
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notmode92p:
 cmp.w #$210a,d5 ;check if DIAMOND+MODE
 bne notdiammode92p
 move.w #$723,(a2) ;change event to CM_STRING
 move.l window92p(PC),a3 ;check if home screen is active
 btst.b #7,(a3)
 beq simplecube92p
 move.l params92p(PC),a3
 btst.b #1,16(a3) ;if yes, check if cursor is in entry line
 beq simplecube92p
 tst.w (a3) ;if yes, check if ans(1) should be added
 beq anscube92p
 btst.b #5,17(a3)
 beq simplecube92p
 tst.w 6(a3)
 bne notbeginning392p
 move.w 2(a3),d2
 cmp.w (a3),d2
 bne simplecube92p
 bra anscube92p
notbeginning392p:
 tst.w 2(a3)
 bne simplecube92p
 move.w 6(a3),d2
 cmp.w (a3),d2
 bne simplecube92p
anscube92p:
 move.l #$1000b,-(a7)
 pea.l ans1tag92p(PC)
 ROM_CALL Parse1DExpr ;convert ans(1) to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq simplecube92p ;if yes, don't add ans(1)
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
anscubenext92p: ;add ^3 to ans(1)
 move.b (a0),(a1)+
 cmp.b #')',(a0)+
 bne anscubenext92p
 move.b #'^',(a1)+
 move.b #'3',(a1)+
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.l a3,8(a2)
 bra notkeypress92p ;do nothing more
simplecube92p:
 lea.l txt_cube92p(PC),a0 ;insert ^3
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notdiammode92p:
 cmp.w #$205e,d5 ;check if DIAMOND+^
 bne notdiampower92p
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_xroot92p(PC),a0 ;insert x\root(
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notdiampower92p:
 cmp.w #$2106,d5 ;check if DIAMOND+ln
 bne notdiamln92p
 move.w #$723,(a2) ;change event to CM_STRING
 lea.l txt_xlog92p(PC),a0 ;insert x\logy(
 move.l a0,8(a2)
 bra notkeypress92p ;do nothing more
notdiamln92p:
 cmp.w #$2103,d5 ;check if DIAMOND+sin
 bne notdiamsin92p
 move.l #$1000a,-(a7)
 pea.l abstag92p(PC)
 ROM_CALL Parse1DExpr ;convert abs to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress92p ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
absnext92p:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne absnext92p
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert abs(
 bra notkeypress92p ;do nothing more
notdiamsin92p:
 cmp.w #$2104,d5 ;check if DIAMOND+cos
 bne notdiamcos92p
 move.l #$1000a,-(a7)
 pea.l ncrtag92p(PC)
 ROM_CALL Parse1DExpr ;convert nCr to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress92p ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
ncrnext92p:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne ncrnext92p
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert nCr(
 bra notkeypress92p ;do nothing more
notdiamcos92p:
 cmp.w #$2105,d5 ;check if DIAMOND+tan
 bne notdiamtan92p
 move.l #$1000a,-(a7)
 pea.l nprtag92p(PC)
 ROM_CALL Parse1DExpr ;convert nPr to local string
 addq.l #8,a7
 tst.w d0 ;check if NULL handle
 beq notkeypress92p ;if yes, don't treat the keypress
 move.w d0,-(a7)
 ROM_CALL HeapDeref
 lea.l funcbuffer92p(PC),a1
 move.l a1,a3
nprnext92p:
 move.b (a0),(a1)+
 cmp.b #'(',(a0)+
 bne nprnext92p
 clr.b (a1)
 ROM_CALL HeapFree
 addq.l #2,a7
 move.w #$723,(a2) ;change event to CM_STRING
 move.l a3,8(a2) ;insert nPr(
 bra notkeypress92p ;do nothing more
notdiamtan92p:
 cmp.w #$2108,d5 ;check if DIAMOND+ESC
 bne notdiamesc92p
 clr.w -(a7)        ;hide diamond indicator now (else the
 ROM_CALL ST_modKey ;auto-int 1 will do it, but too late)
 subq.l #2,a7
 move.l #3840,(a7)
 ROM_CALL HeapAllocPtr
 move.l a0,d4 ;save the address to d4
 tst.l d4
 beq diamescnomem92p ;if NULL pointer, don't display key map
 move.l #$4c00,-(a7)
 move.l d4,-(a7)
 ROM_CALL memcpy ;save the screen
 addq.l #8,a7
 pea.l keymap92p(PC)
 move.l #$4c00,-(a7)
 ROM_CALL memcpy ;display the key map
 addq.l #6,a7
 move.w #2,(a7)
 ROM_CALL FontSetSys
 move.w d0,(a7)
 clr.w -(a7)
 pea.l keymaptext92p(PC)
 move.l #$59006e,-(a7)
 ROM_CALL DrawStr
 lea.l 10(a7),a7
 ROM_CALL FontSetSys
 subq.l #2,a7
 ROM_CALL ngetchx ;wait for a keypress
 move.l d4,(a7)
 move.l #$4c00,-(a7)
 ROM_CALL memcpy ;restore the screen
 addq.l #4,a7
 ROM_CALL HeapFreePtr
 addq.l #4,a7
diamescnomem92p:
 addq.l #4,a7
 move.w #$700,(a2) ;change event to CM_IDLE
 bra notkeypress92p ;do nothing more
notdiamesc92p:
 cmp.w #$2028,d5 ;check if DIAMOND+(
 bne notkeypress92p
 lea.l event92p(PC),a0
 move.w #$710,(a0)
 lea.l event_keycode92p(PC),a0 ;insert the keycode of the Napier / Euler e into
 move.l #150*65536+150,(a0)    ;the event structure
 pea.l event92p(PC) ;CM_KEYPRESS event for the Napier/Euler e
 move.w #-2,-(a7)
 ROM_CALL EV_sendEvent ;send the CM_KEYPRESS event to the current application
 addq.l #6,a7 ;We have to send an additional event because we have to keep the
              ;self-test key working.
notkeypress92p:
 move.l oldevent92p(PC),a0 ;a0 = old event hook
 cmp.l #0,a0 ;check if 0 (tst refuses this addressing mode)
 beq nooldevent92p ;if 0 do nothing
 move.l 64(a7),a2 ;pass event structure in a2 (for TeOS)
 move.l a2,-(a7) ;pass event structure as an argument
 jsr (a0) ;run the old event hook
 addq.l #4,a7
nooldevent92p:
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
 EVEN ;avoid silly alignment problems
      ;("Address Error" etc.)
statusflags92p: dc.w 0 ;placeholder for the status flags
statusflags292p: dc.w 0
params92p: dc.l $6016;position of the home screen entry line
                     ;parameters
window92p: dc.l $6071;position of the 2nd byte of the home
                     ;screen window flags (containing the
                     ;"active" flag)
;Those values may be adjusted for different AMS versions.
event92p: ;event structure for EV_sendEvent
 dc.w $710 ;type = CM_STRING
 ds.b 6 ;RunningApp (2), Side (2), StatusFlags (2)
event_keycode92p:
 dc.w 150,150 ;Mod (2), Code (2)
 ds.b 2 ;StartType (2)
keymap92p:
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$13,$e4,$40,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $04,$1c,$00,$00,$00,$01,$07,$00,$00,$00,$00,$00,$01,$22,$02,$80,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0a,$22,$00,$00,$00,$02,$88,$80,$00,$00,$00,$00,$01,$42,$01,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $11,$02,$00,$00,$00,$04,$40,$80,$00,$00,$00,$00,$01,$83,$c1,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$04,$00,$00,$00,$00,$07,$00,$00,$00,$00,$00,$01,$42,$01,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$08,$00,$00,$00,$00,$00,$80,$0e,$22,$39,$f0,$01,$22,$01,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$10,$00,$00,$00,$00,$08,$80,$11,$22,$10,$40,$01,$13,$e1,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$3e,$00,$00,$00,$00,$07,$00,$11,$22,$10,$40,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$11,$22,$10,$40,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$11,$22,$10,$40,$01,$10,$87,$80,$01,$00,$00,$00,$00,$00,$00,$10,$00,$00,$10,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$0e,$22,$10,$40,$01,$b1,$44,$40,$01,$00,$00,$00,$00,$00,$00,$10,$00,$00,$10,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$01,$1c,$38,$40,$01,$52,$24,$40,$01,$00,$00,$00,$00,$00,$00,$10,$00,$00,$38,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$00,$00,$00,$01,$12,$27,$80,$01,$00,$00,$00,$00,$00,$00,$10,$00,$00,$38,$00,$00,$00
 dc.b $10,$00,$88,$e3,$87,$c0,$00,$80,$00,$00,$00,$00,$01,$13,$e4,$00,$01,$00,$00,$00,$00,$0e,$2c,$70,$00,$00,$7c,$00,$00,$00
 dc.b $10,$00,$d9,$12,$44,$00,$00,$80,$00,$00,$00,$00,$01,$12,$24,$00,$01,$00,$00,$00,$00,$11,$32,$90,$00,$00,$7c,$00,$00,$00
 dc.b $10,$00,$a9,$12,$24,$00,$00,$80,$00,$00,$00,$00,$01,$12,$24,$00,$01,$00,$00,$00,$00,$20,$a2,$90,$00,$00,$fe,$00,$00,$00
 dc.b $10,$00,$89,$12,$27,$80,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$a2,$60,$00,$00,$fe,$00,$00,$00
 dc.b $10,$00,$89,$12,$24,$00,$00,$80,$00,$7f,$ff,$ff,$ff,$fc,$00,$00,$01,$00,$00,$00,$04,$00,$80,$00,$00,$81,$ff,$00,$00,$00
 dc.b $10,$00,$89,$12,$44,$00,$00,$80,$00,$40,$00,$00,$00,$04,$00,$00,$01,$00,$00,$00,$04,$00,$80,$00,$00,$81,$ff,$00,$00,$00
 dc.b $10,$00,$88,$e3,$87,$c0,$00,$80,$00,$40,$00,$00,$00,$04,$00,$00,$01,$00,$00,$00,$04,$01,$00,$00,$00,$83,$ff,$80,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$40,$00,$00,$00,$04,$00,$00,$01,$00,$00,$00,$3f,$82,$00,$00,$07,$f3,$ff,$80,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$5f,$f8,$1e,$01,$f4,$00,$00,$01,$00,$00,$00,$04,$04,$00,$00,$00,$81,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$21,$02,$04,$00,$00,$01,$00,$00,$00,$04,$08,$00,$00,$00,$81,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$40,$84,$04,$00,$00,$01,$00,$00,$00,$04,$10,$00,$00,$00,$80,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$80,$44,$04,$00,$00,$01,$00,$00,$00,$00,$20,$00,$00,$00,$00,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$80,$08,$04,$00,$00,$01,$00,$00,$00,$00,$3f,$80,$00,$00,$00,$7c,$00,$00,$00
 dc.b $04,$38,$20,$00,$00,$0c,$00,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7c,$00,$00,$00
 dc.b $0c,$44,$50,$00,$00,$04,$00,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$38,$00,$00,$00
 dc.b $14,$44,$88,$00,$00,$04,$63,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$38,$00,$00,$00
 dc.b $04,$44,$00,$00,$00,$04,$94,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$10,$00,$00,$00
 dc.b $04,$44,$00,$00,$00,$04,$94,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$10,$00,$00,$00
 dc.b $04,$44,$00,$00,$00,$0e,$63,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0e,$38,$00,$00,$00,$00,$00,$80,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$07,$00,$00,$50,$01,$00,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$80,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$50,$00,$80,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$dd,$c1,$df,$7f,$ff,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$50,$00,$40,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$db,$df,$ee,$ff,$ff,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$50,$00,$20,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$d7,$df,$f5,$ff,$ff,$00,$00,$00
 dc.b $10,$01,$c8,$1f,$08,$78,$00,$80,$00,$50,$00,$10,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$cf,$c3,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$02,$08,$10,$14,$44,$00,$80,$00,$50,$00,$08,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$d7,$df,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$04,$08,$10,$22,$44,$00,$80,$00,$5f,$f0,$04,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$db,$df,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$04,$08,$1e,$22,$78,$00,$80,$00,$50,$00,$02,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$dd,$df,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$04,$08,$10,$3e,$50,$00,$80,$00,$50,$00,$01,$08,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$dd,$c1,$fb,$ff,$ff,$00,$00,$00
 dc.b $10,$02,$08,$10,$22,$48,$00,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
 dc.b $10,$01,$cf,$9f,$22,$44,$00,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$00,$00,$00,$3f,$ff,$ff,$ff,$ff,$ff,$ff,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$10,$00,$00,$00,$0c,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$28,$00,$00,$00,$04,$00,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $06,$44,$00,$00,$00,$04,$63,$00,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $09,$00,$00,$00,$00,$04,$94,$80,$00,$50,$00,$00,$48,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $1e,$00,$00,$00,$00,$04,$94,$80,$00,$50,$00,$00,$88,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$ae,$63,$80,$00,$50,$01,$00,$84,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $0c,$00,$00,$00,$00,$40,$00,$80,$00,$50,$00,$81,$04,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$a0,$07,$00,$00,$50,$00,$42,$02,$04,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$5f,$fc,$3c,$01,$f4,$00,$00,$01,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$40,$00,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$40,$00,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$7f,$ff,$ff,$ff,$fc,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$10,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$90,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$50,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$50,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$50,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$81,$30,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$f9,$10,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$20,$00,$00,$00,$00,$00,$00,$02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$0c,$00,$00,$00,$00,$00,$00,$00,$60,$00,$00,$00,$00,$00,$00,$06,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$64,$00,$00,$00,$00,$00,$00,$03,$20,$00,$00,$0e,$00,$00,$00,$32,$00,$00,$01,$e0,$00,$00,$00,$00,$00,$00,$28,$00
 dc.b $00,$40,$04,$00,$00,$00,$80,$00,$00,$00,$20,$00,$00,$11,$00,$10,$00,$02,$00,$00,$01,$10,$00,$00,$00,$00,$00,$00,$10,$00
 dc.b $00,$00,$04,$00,$00,$00,$80,$00,$00,$00,$20,$00,$00,$10,$00,$10,$00,$02,$00,$00,$01,$10,$00,$00,$00,$00,$00,$00,$29,$f8
 dc.b $0e,$ca,$00,$00,$00,$0a,$e3,$80,$e6,$38,$00,$00,$02,$90,$58,$1c,$55,$00,$00,$00,$29,$15,$81,$f8,$00,$00,$00,$00,$02,$00
 dc.b $10,$4d,$00,$00,$00,$16,$94,$01,$09,$40,$00,$00,$03,$50,$60,$10,$b6,$80,$00,$00,$35,$e6,$00,$90,$00,$00,$00,$00,$02,$00
 dc.b $0c,$49,$00,$00,$00,$12,$93,$01,$09,$30,$00,$00,$02,$50,$40,$10,$94,$80,$00,$00,$25,$04,$00,$90,$00,$00,$00,$00,$24,$00
 dc.b $02,$49,$00,$00,$00,$16,$90,$81,$09,$08,$00,$00,$02,$51,$40,$12,$b4,$80,$00,$00,$25,$04,$00,$90,$00,$00,$00,$00,$14,$00
 dc.b $1c,$e9,$00,$00,$00,$0a,$67,$00,$e6,$70,$00,$00,$02,$4e,$40,$0c,$54,$80,$00,$00,$25,$04,$00,$90,$00,$00,$00,$00,$08,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$81,$ff,$ff,$ff,$ff,$ff,$ff,$f8,$1f,$ff,$ff,$ff,$ff,$ff,$ff,$81,$ff,$ff,$ff,$ff,$ff,$ff,$f8
 dc.b $10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08,$10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08,$10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$03,$87,$11,$00,$00,$81,$00,$00,$38,$e1,$c0,$00,$08,$10,$00,$0f,$84,$22,$00,$00,$81,$00,$00,$00,$10,$00,$00,$08
 dc.b $10,$00,$04,$42,$19,$00,$00,$81,$00,$00,$41,$12,$20,$00,$08,$10,$00,$02,$0a,$32,$00,$00,$81,$00,$00,$00,$28,$00,$00,$08
 dc.b $10,$00,$04,$02,$15,$00,$00,$81,$00,$00,$81,$12,$00,$00,$08,$10,$00,$02,$11,$2a,$00,$00,$81,$00,$00,$00,$44,$00,$00,$08
 dc.b $10,$00,$03,$82,$15,$00,$00,$81,$00,$00,$81,$11,$c0,$00,$08,$10,$00,$02,$11,$2a,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$00,$42,$15,$00,$00,$81,$00,$00,$81,$10,$20,$00,$08,$10,$00,$02,$1f,$2a,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$04,$42,$13,$00,$00,$81,$00,$00,$41,$12,$20,$00,$08,$10,$00,$02,$11,$26,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$03,$87,$11,$00,$00,$81,$00,$00,$38,$e1,$c0,$00,$08,$10,$00,$02,$11,$22,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08,$10,$00,$00,$00,$00,$00,$00,$81,$00,$00,$00,$00,$00,$00,$08
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$81,$ff,$ff,$ff,$ff,$ff,$ff,$f8,$1f,$ff,$ff,$ff,$ff,$ff,$ff,$81,$ff,$ff,$ff,$ff,$ff,$ff,$f8
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $06,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dc.b $08,$00,$00,$00,$00,$00,$00,$00,$00,$1f,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$80
 dc.b $08,$00,$00,$00,$00,$00,$03,$00,$00,$7f,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$e0
 dc.b $10,$00,$00,$00,$00,$00,$04,$80,$00,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$f0
 dc.b $08,$00,$00,$00,$00,$00,$0f,$00,$01,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$f8
 dc.b $08,$00,$00,$00,$00,$00,$08,$00,$03,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fc
 dc.b $06,$00,$00,$00,$00,$00,$06,$00,$03,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fc
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$01,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$02,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$04,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$04,$00,$00,$00,$80,$07,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$fe
 dc.b $10,$00,$00,$04,$00,$00,$00,$80,$03,$f0,$73,$bb,$ba,$df,$bf,$af,$d6,$ff,$dd,$bf,$f6,$bd,$fb,$ef,$f5,$bf,$fe,$bf,$f6,$fc
 dc.b $10,$00,$00,$04,$00,$00,$00,$80,$03,$e3,$3d,$55,$39,$aa,$e7,$9d,$b5,$57,$c4,$93,$6d,$aa,$ae,$6b,$6d,$55,$e7,$9e,$6a,$7c
 dc.b $10,$00,$00,$02,$00,$00,$00,$80,$01,$e4,$3b,$55,$b9,$9a,$ab,$9a,$94,$cf,$d5,$b5,$ed,$99,$aa,$a6,$a5,$33,$de,$ae,$a6,$f8
 dc.b $10,$00,$00,$01,$00,$00,$00,$80,$00,$e3,$31,$bb,$ba,$cd,$ab,$ad,$b6,$5f,$d6,$d3,$5b,$ac,$da,$ab,$6d,$97,$66,$9a,$b3,$70
 dc.b $10,$00,$00,$00,$00,$00,$00,$80,$00,$70,$7f,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$f7,$ff,$ff,$ff,$ff,$ff,$ff,$fd,$ff,$ff,$e0
 dc.b $1f,$ff,$ff,$ff,$ff,$ff,$ff,$80,$00,$1f,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$80
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
keymaptext92p: dc.b 'XtraKeys v. 2.31',0
txt_10exp92p: dc.b '10^(',0
txt_square92p: dc.b '^2',0
txt_cube92p: dc.b '^3',0
txt_xroot92p: dc.b 'x\root(',0
txt_xlog92p: dc.b 'x\logy(',0
 dc.b $08 ;tokenized expressions for localization support
abstag92p: dc.b $4b
 dc.b $08
logtag92p: dc.b $54
 dc.b $09,$08
ncrtag92p: dc.b $a7
 dc.b $09,$08
nprtag92p: dc.b $a8
 dc.b $e5,$01,$01,$1f
ans1tag92p: dc.b $bc
funcbuffer92p: ds.b 15
endevent92p:

;byte-aligned data here:
installedST: dc.b 'XtraKeys 2.31 by Kevin Kofler installed',0
nomemST: dc.b 'ERROR: not enough memory',0
 dc.b 'x'
foldersym: dc.b 0
 dc.b 'x\root'
rootsym: dc.b 0
 dc.b 'x\logy'
logysym: dc.b 0
rootdata:
;This is tokenized TI-BASIC for:
;x\root(x,y)=y^(1/x)
 dc.b 0,17,$e9,1,1,$1f,8,$f0,$91,9,$f0,$93,$e5,9,8,0,1,$40,$dc
logydata:
;This is tokenized TI-BASIC for:
;x\logy(x,y)=ln(y)/ln(x)
 dc.b 0,15,$e9,9,$f0,$53,8,$f0,$53,$91,$e5,9,8,0,1,$40,$dc

 END
